
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>G1垃圾收集器介绍 / iVAN</title>

    <meta name="description" content="G1垃圾收集器介绍 原文链接,译者:Greenster 简介 Oracle在JDK7 update 4之后开始完全支持G1垃圾收集器,G1是一个针对多处理器大容量内存的服务器端的垃圾收集器,其目标是在实现高吞吐量的同时,尽可能的满足垃圾收集暂停时间的要求.G1在执行一些Java堆空间中的全区域操作(如:全局标记)时是和应用程序线程并发进行的,因此减少了Java堆空间的中断比例.(译者注:可简单理解为减少了Stop-the-World的时间比例) 技术说明 G1收集器通过下面一些方法实现了高性能和减少暂停时间的目的.">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">G1垃圾收集器介绍</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><a href="http://www.oracle.com/technetwork/java/javase/tech/g1-intro-jsp-135488.html" rel="external nofollow noreferrer">原文链接</a>，译者：Greenster</p>
<h2>简介</h2>
<p>Oracle在JDK7 update 4之后开始完全支持G1垃圾收集器，G1是一个针对多处理器大容量内存的服务器端的垃圾收集器，其目标是在实现高吞吐量的同时，尽可能的满足垃圾收集暂停时间的要求。G1在执行一些Java堆空间中的全区域操作（如：全局标记）时是和应用程序线程并发进行的，因此减少了Java堆空间的中断比例。（译者注：可简单理解为减少了Stop-the-World的时间比例）</p>
<h2><strong>技术说明</strong></h2>
<p>G1收集器通过下面一些方法实现了高性能和减少暂停时间的目的。</p>
<p>首先将Java堆空间划分为一些大小相等的区域（region），每个区域都是虚拟机中的一段连续内存空间。G1通过执行并发的全局标记来确定整个Java堆空间中存活的对象。标记阶段完成后，G1就知道哪些区域基本上是空闲的。在回收内存时优先回收这些区域，这样通常都会回收相当数量的内存。这就是为什么它叫做Garbage-First的原因。顾名思义G1关注某些区域的回收和整理，这些区域中的对象很有可能被完全回收。而且G1使用了一个暂停时间预测模型使得暂停时间控制在用户指定的暂停时间内，并根据用户指定的暂停时间来选择合适的区域回收内存。</p>
<p>G1确定了可回收的区域后就是筛选回收（evacuation）阶段了。在此阶段将对象从一个或多个区域复制到单一区域，同时整理和释放内存。该阶段是在多个处理器上多个线程并行进行的，因此减少了暂停时间并提高了吞吐量。G1在每一次的垃圾收集过程中都不断地减少碎片，并能够将暂停时间控制在一定范围内。这些已经是以前的垃圾收集器无法完成的了。比如：CMS收集器并不做内存整理。ParallelOld收集器只是对整个Java堆空间做整理，这样导致相当长的暂停时间。</p>
<p>关于G1很重要的一点是它并不是一个实时收集器。尽管在绝大多数情况下都能够满足暂停时间的要求，但并非没有例外。因为G1是基于之前数次垃圾收集的经验值来估计在用户指定的暂停时间内有多少区域可以收集。因此它对于在区域上执行收集的成本有一个合理的较为精确的模型，并使用该模型来确定对哪些区域执行收集。</p>
<p>对于更详细的关于使用和配置G1的信息请参考<a href="http://www.oracle.com/technetwork/java/javase/tech/vmoptions-jsp-140102.html" rel="external nofollow noreferrer">JAVA虚拟机参数</a>。</p>
<h2><strong>推荐使用</strong><strong>的场景</strong></h2>
<p>G1的首要目的是为那些需要大容量内存和较小GC延迟的应用程序提供解决方案。这通常是指那些堆大小设置在6GB以上，确定的、可以预测的暂停时间在0.5秒以内的应用程序。</p>
<p>如果应用程序符合以下一项或者多项特征，那么从CMS或者ParallelOld收集器切换到G1可能更合适。</p>
<ul>
<li>活动对象占据了超过50%的Java堆空间。</li>
<li>对象分配率或者提升率波动明显。</li>
<li>不希望有长时间的垃圾收集暂停时间（超过0.5秒或1秒）。</li>
</ul>
<h2>G1的前景</h2>
<p>G1的使命是替换掉CMS收集器。通过对比G1和CMS收集器，可以发现G1是更好的一种解决方案。首先G1是一个压缩收集器，G1通过充分的压缩完全避免了使用细粒度的空闲列表（free lists）来分配内存，而是使用相对粗粒度的区域（regions）来分配内存。这明显简化了收集器，也很大程度上减少了内存碎片化的问题。此外，相比较CMS，G1可以预测出垃圾收集的暂停时间，并允许用户指定期望的暂停时间。</p>
<p>如果你有兴趣改善G1，请通过OpenJDK和邮件列表hotspot-gc-use@openjdk.java.net给我们反馈。 </p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 17:13:36</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>G1垃圾收集器介绍的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pL7GlRM.html" rel="bookmark">深入理解G1垃圾收集器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				G1 GC是Jdk7的新特性之一.Jdk7+版本都可以自主配置G1作为JVM GC选项:作为JVM GC算法的一次重大升级.DK7u后G1已相对稳定.且未来计划替代CMS.所以有必要深入了解下: 不同于其他的分代回收算法.G1将堆空间划分成了互相独立的区块.每块区域既有可能属于O区.也有可能是Y区,且每类区域空间可以是不连续的(对比CMS的O区和Y区都必须是连续的).这种将O区划分成多块的理念源于:当并发后台线程寻找可回收的对象时.有些区块包含可回收的对象要比其他区块多很多.虽然在清理这些区块时			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmR6P1z.html" rel="bookmark">JVM垃圾收集器介绍</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.垃圾回收用到的主要算法 1.引用计数法 算法思路: 给对象中添加一个引用计数器,每当有一个地方引用他时,计数器值就加1:当引用失效时,计数器值就减1:当计数器的值为0时就可以把该对象删除. 算法优点: 实现简单,判定效率高 算法缺点: 难以解决对象之间相互循环引用的问题. 2.标记清除法 算法思路: 算法分为&quot;标记&quot;和&quot;清除&quot;两个阶段:首先标记出所有需要回收的对象,在标记完成后统一回收所有被标记的对象. 算法优点:     算法缺点: 效率低,标记和清除两个过程			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYjyVBp.html" rel="bookmark">垃圾收集器Serial 、Parallel、CMS、G1</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这里介绍4个垃圾收集器,如果进行了错误的选择将会大大的影响程序的性能.     时至今日,仍然有两个事情困扰着开发人员:垃圾收集(GC)和了解异性(程序猿的悲鸣),后者我确实不太了解,因为我被前者搞的无暇顾及怎么了解异性,特别是当知道在JAVA8中对这一区域有了很大的改进和提升还有移除了PermGen和以一些新的令人兴奋的调优.     当我们谈到垃圾回收时,我们绝大多数都知道利用它的概念在我们日常的编程中.但是,当问题出现时,会发现很多是我们不知道的.JVM 最大误区之一就是它只有一个垃圾回收			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXdq9Kp.html" rel="bookmark">Garbage First（G1）垃圾收集器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				引言:G1垃圾收集器采用一个略微不同的手段来解决并行.串行以及CMS GC的众多缺陷.对于大的Java堆来说,通过将Java堆拆分成一个个分区,G1会比其他垃圾收集器有更好的综合表现.本文选自&lt;Java性能调优指南&gt;. G1垃圾收集器采用一个略微不同的手段来解决并行.串行以及CMS GC的众多缺陷.G1将堆拆成一系列的分区,这样在一个时间段内,大部分的垃圾收集操作就只是在一个分区内执行,而不是整个堆或整个(老年)代. 在G1里,年轻代就是一系列的内存分区,这意味着不用再要求年轻代是一个连续的内			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zenBLNb.html" rel="bookmark">我们的垃圾收集器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				(译者注:这篇博文发表在2008年,虽然年代有些久远,但是文中说到的垃圾收集器我们至今还在使用,作者也谈到了对于G1垃圾收集器的期望.) 最近我在白板上给客户化了一个图表,他们似乎对这个有点兴趣,所以我想我可以重画一遍来给你们消遣. 每个蓝色的盒子都代表了一个收集器,用来收集某一代.黄色区域中的蓝色盒子是用来收集新生代的,灰色区域中的蓝色盒子是用来收集老年代的. Serial&quot;是一个单线程.stop-the-world.使用复制算法的收集器. &quot;ParNew&quot; 是一个多线程.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLmPwRz.html" rel="bookmark">深入理解JVM之四：详解垃圾收集器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 前面已经对垃圾收集算法有了较为详细的介绍,这里我们将对JVM中具体的垃圾回收器进行介绍,在虚拟机规范中并没有对垃圾回收器如何实现具体介绍,因此每个厂商的垃圾回收器可能会完全不同,但是我们介绍的是基于JDK1.7之后的Hotspot虚拟机(包括前面对Java虚拟机的介绍也是基于jdk1.7版本的).在Hotspot中,虚拟机的收集器主要有下: 可以看到垃圾收集器是按对象的分代来划分的,可以用线条连接的垃圾回收器表示两者可以配合使用.可以看到新生代垃圾收集器有Serial.ParNew.Par			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlL0DnM.html" rel="bookmark">G1 收集器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				G1是一款面向服务端应用的垃圾收集器.初次发布是在JDK 7这一版本中.长久的目标是替代CMS收集器. 1.介绍 1.1 G1收集器通过下面一些方法实现了高性能和减少暂停时间的目的 首先将Java堆空间划分为一些大小相等的区域(region),每个区域都是虚拟机中的一段连续内存空间.G1通过执行并发的全局标记来确定整个Java堆空间中存活的对象.标记阶段完成后,G1就知道哪些区域基本上是空闲的.在回收内存时优先回收这些区域,这样通常都会回收相当数量的内存.这就是为什么它叫做Garbage-Fir			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqrKdRp.html" rel="bookmark">java中HotSpot算法及垃圾收集器简介</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				垃圾回收算法基本思想: 1.枚举根节点(GC Roots) 在垃圾回收时,我们要想办法找出哪些对象是存活的,一般会选取一些被称为GC Root的对象,从这些对象开始枚举.枚举时要求所有对象停下来,也就是大家所称的&quot;Stop the world&quot;.所有的算法实现都会将虚拟机停下来的,否则分析结果的准确性将无法保证.当执行系统停顿下来之后,虚拟机不需要遍历所有的根节点和上下文去确定GC Roots,而是存在着一个OopMap的数据结构来达到这个目的.在类加载完成的时候,虚拟机就会把什么类的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bo7Xwdb.html" rel="bookmark">jdk1&period;7  HotSpot虚拟机 怎么查看使用的哪种垃圾收集器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 jdk1.7 HotSpot虚拟机 怎么查看使用的哪种垃圾收集器 怎么查看虚拟机使用的哪种垃圾收集器?是G1,还是CMS? 启动java的参数中没有配置-XX:+UseG1GC这种参数 $ ./java -version java version &quot;1.7.0_45&quot; Java(TM) SE Runtime Environment (build 1.7.0_45-b18) Java HotSpot(TM) 64-Bit Server VM (build 24.45-b08,			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0boE0gp.html" rel="bookmark" class="title">用&period;Net开发DB2应用程序比较</a>
					<div>
						比较|程序 简介 在.NET应用软件开发人员看来,使用DB2与使用其它任何其它关系数据库没有区别.人们可以看到无数使用SQL Server以及甲骨文公司产品执行数据库任务的例子,但关于使用包括.NET ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMgLNOp.html" rel="bookmark" class="title">javascript 应用－ 操作节点的函数</a>
					<div>
						javascript|函数 d1.removeNode(true);oUL1.insertBefore(nod, oLIYellow);&lt;br&gt;   var oCloneNode = oL ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vMN9Kyb.html" rel="bookmark" class="title">Flash绘图功能制作奶瓶标志</a>
					<div>
						核心提示:Flash绘图功能制作奶瓶标志 随着flash的发展,现在已经到了CS3的时代,而且对于AS的支持一带比一带强,可是大家(特别是新手)可能会忽略了一点,其实flash最开始是用来做动画的软件 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/rz4nNjM.html" rel="bookmark" class="title">SEO优化的最高层次是针对口碑的优化</a>
					<div>
						以前我们谈起SEO,大多局限在我的网站在搜什么关键词排在什么位置这样一个层次,这个理解下的SEO,无非是发帖子.发链接.改代码这个级别的. 实际上这样理解SEO是非常片面的. 我将SEO分四个层次,第 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3NXN3z.html" rel="bookmark" class="title">SuSE Linux系统下设定Apache的方法</a>
					<div>
						Apache需要设定成虚拟网站空间方式. 新版SuSE的Apache已经改成模组化. 所以只要修改几个档案就可以在建立帐号时,网站就对应的到位置. 而不用去修改http.conf一个个建对应/home ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGj63Op.html" rel="bookmark" class="title">如何利用Connectify笔记本变无线路由</a>
					<div>
						第一步.双击安装文件进入下图所示 点击红框中的&quot;I Agree&quot;稍等片刻就会安装完成 第二步 安装完成后会运行软件(以下步骤都请按图中红色表示操作) 第三步 继续按图操作 第四步  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwlvjnb.html" rel="bookmark" class="title">javascript显式类型转换实例分析</a>
					<div>
						  javascript显式类型转换实例分析         这篇文章主要介绍了javascript显式类型转换,实例分析了javascript实现类型转换的常用技巧,非常具有实用价值,需要的朋友可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd6GlNb.html" rel="bookmark" class="title">怎么让Excel表格自动调整字号</a>
					<div>
						  选中需要调整字号的单元格区域,依次选择&quot;格式→单元格&quot;菜单命令,出现&quot;单元格格式&quot;对话框,选择&quot;对齐&quot;选项卡,在&quot;文本控制&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOam98M.html" rel="bookmark" class="title">ps打造日系清新美女技巧</a>
					<div>
						眼看着冬季来了,温度渐渐下降,如果不想外出挨冻,就开始室内人像拍摄吧.担心效果不理想?放心吧,下面就教你用简单的5步解决色彩的问题. 冬季室内拍摄也要小清新?没问题!通过简单5步后期工作,让小清新充满 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo7lQgb.html" rel="bookmark" class="title">Word 2010中前面几页不显示页码的方法</a>
					<div>
						  我是公司的一名文员,编辑文档时,前面几页如:封面.前言.简介.目录等部分都不能有页码,而从第6页的正文开始才显示页码.我在Word中找了好久也没找到能让前面5页不显示页码的方法,请帮忙想个办法解决 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MArq72p.html" rel="bookmark" class="title">笔记本wifi热点设置教程</a>
					<div>
						如何让笔记本成为wifi热点呢?本文以windows xp系统作wifi热点向大家介绍一下具体的操作方法,如果你还不会的话赶紧来学习吧! ⒈如下图所示:单击鼠标右键那个网络图标,选择&quot;打开网 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3oegwb.html" rel="bookmark" class="title">ECMAScript 5中的属性描述符详解&lowbar;基础知识</a>
					<div>
						属性描述符是ES5中新增的概念,其作用是给对象的属性增加更多的控制. Object.defineProperty 要研究属性描述符,首先要谈谈 Object.defineProperty 方法.这个方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bamBLQb.html" rel="bookmark" class="title">给大家共享一个基本算法包</a>
					<div>
						下载地址    http://www.cppblog.com/Files/huyi/datastruct.rar 包含内容:下面是文档包含的内容:二分查找1.c二分查找2.c二叉树.c其它 单元加单循 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgVQxAb.html" rel="bookmark" class="title">MIME简介</a>
					<div>
						MIME(Multipurpose Internet Mail Extensions)多用途互联网邮件扩展类型.是设定某种扩展名的文件用一种应用程序来打开的方式类型,当该扩展名文件被访问的时候,浏览器 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqA1kaM.html" rel="bookmark" class="title">Android 自定义View 三板斧之二&mdash;&mdash;组合现有控件</a>
					<div>
						通常情况下,Android实现自定义控件无非三种方式. Ⅰ.继承现有控件,对其控件的功能进行拓展. Ⅱ.将现有控件进行组合,实现功能更加强大控件. Ⅲ.重写View实现全新的控件 上文说过了如何继承现 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NnkgM.html" rel="bookmark" class="title">2017年能源行业在大数据和人工智能领域的投资增长10倍</a>
					<div>
						根据最近发布的一份报告,能源行业2017年在大数据和人工智能领域的投资增长了10倍. 调查机构BDO会计师事务所进行的研究发现,涉及能源公司和人工智能初创公司的并购活动的投资由2017年第一季度的约5 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2PqGvp.html" rel="bookmark" class="title">declspec-vs2008 mfc无法生成exe</a>
					<div>
						问题描述 vs2008 mfc无法生成exe 我在用vs2008编译编译时报以下错误: 1&gt;qmfcapp.obj : error LNK2019: 无法解析的外部符号 &quot;__decl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV0LknM.html" rel="bookmark" class="title">core Animation之CAKeyframeAnimation&lpar;关键帧动画&rpar;</a>
					<div>
						CABasicAnimation的区别是:CABasicAnimation只能从一个数值(fromValue)变到另一个数值(toValue),而CAKeyframeAnimation会使用一个NSA ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmKJNab.html" rel="bookmark" class="title">IT工程师升职加薪必备的五大云计算资格证书</a>
					<div>
						裁员潮!估值下调!不仅仅是硅谷正步入寒冬,国内的创业寒潮也凛冽地来了.随着市场对经典IT架构的需求减弱和行业萎缩影响,不少传统IT企业的技术人员,也面临着失业和转行的风险. 但与此同时,云计算市场正快 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Rqqmz.html" rel="bookmark" class="title">城商行的未来之路（上）</a>
					<div>
						Future way of city commercial banks (First part) 文 /张吉光 极少数规模较大.经营管理水平较高的特大型城商行,通过机构扩张,发展成提供全面金融服务.在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5RowWz.html" rel="bookmark" class="title">上海举措：早晚高峰禁用打车软件</a>
					<div>
						26日,针对打车软件引起的混乱状况,上海市交通运输和港口管理局发布消息,对打车软件进入出租车行业,将进一步依法合规管理,禁止出租车在早晚高峰时段使用打车软件.昨天,经过多方洽谈,嘀嘀打车和快的打车将接 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdyv0xz.html" rel="bookmark" class="title">&lbrack;Android&rsqb;aapt命令小结</a>
					<div>
						aapt命令小结  aapt即Android Asset Packaging Tool.本文小结了一下该工具的用法.  1.  aapt l[ist] [-v] [-a] file.{zip,jar, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBgd9AM.html" rel="bookmark" class="title">tomcat-mac系统的jenkins持续集成问题</a>
					<div>
						问题描述 mac系统的jenkins持续集成问题 请问安装好tomcat和jenkins后,新建job 构建,生成的workspace不在jobs下,为什么呢,找不到原因,求大神们帮忙 解决方案 to ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJOVq8b.html" rel="bookmark" class="title">14款经典网页图片和文字特效的jQuery插件-前端开发必备&lowbar;jquery</a>
					<div>
						不废话了,直接贴图片了,亲们可以点击查看演示和下载源码哦. 经典1.网页图片3d旋转jQuery代码 查看演示  下载插件 经典2.存css3实现的tabl选项卡代码 查看演示 下载插件 经典3.jQ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ1590b.html" rel="bookmark" class="title">ASP面向对象编程探讨及比较&lowbar;ASP CLASS类</a>
					<div>
						ASP面向对象编程探讨及比较     选择自 RAINMAN_NET 的 Blog   关键字   ASP面向对象编程探讨及比较  出处      ASP是Microsoft于较早期推出的动态网页编程 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDk810p.html" rel="bookmark" class="title">PHP服务缓存优化之ZendOpcache、xcache、eAccelerator对比</a>
					<div>
						PHP服务缓存优化原理 Nginx 根据扩展名或者过滤规则将PHP程序请求传递给解析PHP的FCGI,也就是php-fpm进程 缓存操作码(opcode) Opcode,PHP编译后的中间文件,缓存给 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3ZwV0z.html" rel="bookmark" class="title">《LDA漫游指南》&mdash;&mdash;2&period;3　Beta分布（Beta distribution）</a>
					<div>
						2.3 Beta分布(Beta distribution) 在概率论中,Beta分布是指一组定义在区间(0,1)的连续概率分布,有两个参数alpha 和beta ,且alpha ,beta &gt;  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zG1w5lM.html" rel="bookmark" class="title">微软热捧云计算  微软CEO畅谈看法</a>
					<div>
						当地时间周四,微软CEO史蒂夫鲍尔(Steve Ballmer)在华盛顿大学发表演讲时称,在该公司4万名软件开发员工中,70%使用了云计算技术,占了绝大部分比例,而1年后这一比例将提高到90%.由此可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MA6YJZp.html" rel="bookmark" class="title">来自科讯网受害者的控诉：我如何一步步掉入陷阱</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 以上为科讯网展示的企业信息和众多认证文件. 法治周末记者 蔡长春 拨通黄旭(化名)电话的时候,他正在去往杭州市淳安县公安局报案的路上. 今年3月以来,黄 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3E2lNp.html" rel="bookmark" class="title">比Wi-Fi牛的Li-Fi是什么？</a>
					<div>
						即使你从来没有听说过 Li-Fi,你现在也可以知道它到底是个什么东西.Li-Fi(Light Fidelity)是一种新型无线网络连接技术,它是主要通过可见光频谱来实现无线数据的传播.这项激动人心的技 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
